"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Files = void 0;
exports.createTempFolder = createTempFolder;
exports.createTempStorageFolder = createTempStorageFolder;

var _promises = require("fs/promises");

var _os = _interopRequireDefault(require("os"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const Files = {
  DatabaseName: '.verdaccio-db.json'
};
/**
 * Create a temporary folder.
 * @param prefix The prefix of the folder name.
 * @returns string
 */

exports.Files = Files;

async function createTempFolder(prefix) {
  return await (0, _promises.mkdtemp)(_path.default.join(_os.default.tmpdir(), prefix));
}
/**
 * Create temporary folder for an asset.
 * @param prefix
 * @param folder name
 * @returns
 */


async function createTempStorageFolder(prefix, folder = 'storage') {
  const tempFolder = await createTempFolder(prefix);

  const storageFolder = _path.default.join(tempFolder, folder);

  await (0, _promises.mkdir)(storageFolder);
  return storageFolder;
}
//# sourceMappingURL=file-utils.js.map